(function ($) {
    $.jelastic = $.jelastic || {};
    $.jelastic.api = $.jelastic.api || {};

    $.jelastic.api.TrackingService = function (options) {
        var self;

        self = $.extend($.jelastic.api.AbstractService(options), {
            servicePath : "JElastic/env/tracking/rest/",

            /**
             * @return {Promise}
             */
            getCurrentActions: function () {
                return self.request('getcurrentactions');
            },

            /**
             * @param {String} [starttime]
             * @param {String} [endtime]
             * @param {Number} [count]
             * @return {Promise}
             */
            getUidActions: function (starttime, endtime, count) {
                return self.request('getuidactions', {
                    starttime: starttime,
                    endtime: endtime,
                    count: count
                });
            }
        });

        return self;
    };
})(jQuery);