(function ($) {
    $.jelastic = $.jelastic || {};
    $.jelastic.utils = $.jelastic.utils || {};

    $.jelastic.utils.ActionKey = function () {
        var SEPARATOR = ";",
            SEPARATOR_ESCAPE = "_sc_",
            SEPARATOR_OUTPUT = "->",
            SEPARATOR_ESCAPE_REGEX = new RegExp(SEPARATOR_ESCAPE, "g"),
            self;

        self = {
            decode : function (key) {
                var array,
                    name,
                    input,
                    output,
                    value,
                    id,
                    i,
                    n;

                key = key || "";
                array  = key.split("|");
                id = array[0];
                value = id;

                if (typeof array[0] !== "undefined") {
                    input = array[0].split(SEPARATOR);

                    SEPARATOR_ESCAPE_REGEX.lastIndex = 0;

                    for (i = 0, n = input.length; i < n; i += 1) {
                        input[i] = input[i].replace(SEPARATOR_ESCAPE_REGEX, SEPARATOR);
                    }

                    if (!isNaN(parseInt(input[0], 10))) {
                        id = input.shift();
                    }

                    name = input.splice(0, 1)[0];
                }

                if (typeof array[1] !== "undefined") {
                    output = array[1].split(SEPARATOR);

                    if (output[0] && output[0] === SEPARATOR_OUTPUT) {
                        output.shift();
                    }
                }

                return {
                    id : (id || "").replace(/\s/g, "_"),
                    value: value,
                    name : name,
                    input : input,
                    output : output
                };
            }
        };

        return self;
    };
})(jQuery);